    001    /* ===========================================================
    002     * JFreeChart : a free chart library for the Java(tm) platform
    003     * ===========================================================
    004     *
    005     * (C) Copyright 2000-2008, by Object Refinery Limited and Contributors.
    006     *
    007     * Project Info:  http://www.jfree.org/jfreechart/index.html
    008     *
    009     * This library is free software; you can redistribute it and/or modify it
    010     * under the terms of the GNU Lesser General Public License as published by
    011     * the Free Software Foundation; either version 2.1 of the License, or
    012     * (at your option) any later version.
    013     *
    014     * This library is distributed in the hope that it will be useful, but
    015     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016     * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017     * License for more details.
    018     *
    019     * You should have received a copy of the GNU Lesser General Public
    020     * License along with this library; if not, write to the Free Software
    021     * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022     * USA.
    023     *
    024     * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025     * in the United States and other countries.]
    026     *
    027     * --------------
    028     * PinNeedle.java
    029     * --------------
    030     * (C) Copyright 2002-2008, by the Australian Antarctic Division and
    031     *                          Contributors.
    032     *
    033     * Original Author:  Bryan Scott (for the Australian Antarctic Division);
    034     * Contributor(s):   David Gilbert (for Object Refinery Limited);
    035     *
    036     * Changes:
    037     * --------
    038     * 25-Sep-2002 : Version 1, contributed by Bryan Scott (DG);
    039     * 27-Mar-2003 : Implemented Serializable (DG);
    040     * 09-Sep-2003 : Added equals() method (DG);
    041     * 08-Jun-2005 : Implemented Cloneable (DG);
    042     * 22-Nov-2007 : Implemented hashCode() (DG);
    043     *
    044     */
    045
    046    package org.jfree.chart.needle;
    047
    048    import java.awt.Graphics2D;
    049    import java.awt.geom.Area;
    050    import java.awt.geom.Ellipse2D;
    051    import java.awt.geom.GeneralPath;
    052    import java.awt.geom.Point2D;
    053    import java.awt.geom.Rectangle2D;
    054    import java.io.Serializable;
    055
    056    /**
    057     * A needle that is drawn as a pin shape.
    058     */
    059    public class PinNeedle extends MeterNeedle
    060                           implements Cloneable, Serializable {
    061
    062        /** For serialization. */
    063        private static final long serialVersionUID = -3787089953079863373L;
    064
    065        /**
    066         * Draws the needle.
    067         *
    068         * @param g2  the graphics device.
    069         * @param plotArea  the plot area.
    070         * @param rotate  the rotation point.
    071         * @param angle  the angle.
    072         */
    073        protected void drawNeedle(Graphics2D g2, Rectangle2D plotArea,
    074                                  Point2D rotate, double angle) {
    075
    076            Area shape;
    077            GeneralPath pointer = new GeneralPath();
    078
    079            int minY = (int) (plotArea.getMinY());
    080            //int maxX = (int) (plotArea.getMaxX());
    081            int maxY = (int) (plotArea.getMaxY());
    082            int midX = (int) (plotArea.getMinX() + (plotArea.getWidth() / 2));
    083            //int midY = (int) (plotArea.getMinY() + (plotArea.getHeight() / 2));
    084            int lenX = (int) (plotArea.getWidth() / 10);
    085            if (lenX < 2) {
    086                lenX = 2;
    087            }
    088
    089            pointer.moveTo(midX - lenX, maxY - lenX);
    090            pointer.lineTo(midX + lenX, maxY - lenX);
    091            pointer.lineTo(midX, minY + lenX);
    092            pointer.closePath();
    093
    094            lenX = 4 * lenX;
    095            Ellipse2D circle = new Ellipse2D.Double(midX - lenX / 2,
    096                    plotArea.getMaxY() - lenX, lenX, lenX);
    097
    098            shape = new Area(circle);
    099            shape.add(new Area(pointer));
    100            if ((rotate != null) && (angle != 0)) {
    101                /// we have rotation
    102                getTransform().setToRotation(angle, rotate.getX(), rotate.getY());
    103                shape.transform(getTransform());
    104            }
    105
    106            defaultDisplay(g2, shape);
    107
    108        }
    109
    110        /**
    111         * Tests another object for equality with this object.
    112         *
    113         * @param obj  the object to test (<code>null</code> permitted).
    114         *
    115         * @return A boolean.
    116         */
    117        public boolean equals(Object obj) {
    118            if (obj == this) {
    119                return true;
    120            }
    121            if (!(obj instanceof PinNeedle)) {
    122                return false;
    123            }
    124            if (!super.equals(obj)) {
    125                return false;
    126            }
    127            return true;
    128        }
    129
    130        /**
    131         * Returns a hash code for this instance.
    132         *
    133         * @return A hash code.
    134         */
    135        public int hashCode() {
    136            return super.hashCode();
    137        }
    138
    139        /**
    140         * Returns a clone of this needle.
    141         *
    142         * @return A clone.
    143         *
    144         * @throws CloneNotSupportedException if the <code>PinNeedle</code>
    145         *     cannot be cloned (in theory, this should not happen).
    146         */
    147        public Object clone() throws CloneNotSupportedException {
    148            return super.clone();
    149        }
    150
    151    }